#include <stdio.h>
#include <stdlib.h>

#include "acpi.h"
#include "config.h"
#include "msg.h"

int set_acpi(int newacpi) {
	FILE *fd = NULL;
	char *tmp = (char *) calloc(19, sizeof(char));
	fd = fopen(config.acpi->throttling, "w");
	if(fd == NULL) {
		msg("Unable to set new CPU speed via acpi interface.", LOG_ERROR);
		return ERRVAL;
	}
	fprintf(fd, "%i", newacpi);
	sprintf(tmp, "Changed acpi to %i.", newacpi);
	if(config.loglevel == LOG_NOTE) msg(tmp, LOG_NOTE);
	fclose(fd);
	free(tmp);

	return OKVAL;
}

int get_acpi(void) {
	FILE *fd = NULL;
	char tmp;
	int acpi = -1;

	fd = fopen(config.acpi->throttling, "r");
	if(fd == NULL) {
		msg("Unable to get current acpi throttling state.", LOG_ERROR);
		return ERRVAL;
	}
	while((tmp = fgetc(fd)) != EOF) {
		if(tmp == '*') {
			fgetc(fd);
			acpi = fgetc(fd) - '0';
			break;
		}
	}
	fclose(fd);
	return acpi;
}

int get_ac(void) {
	FILE *fd = NULL;

	fd = fopen(config.acpi->ac_state, "r");
	if(fd == NULL) return ERRVAL;
	
	while(fgetc(fd) != 'o');
	if(fgetc(fd) == 'n') return 1;
	else return 0;
}
